' CopyFile.VBS V1.02 (C) yoshioka.teruo@nifty.com 2005-12-22
' CopyFile.VBS drags files to copy from path name list.
' Usage: CScript.EXE //NoLogo CopyFile.VBS [files...|<stdin]

Option Explicit
Dim File
Dim Files
Files=Array()
If WScript.Arguments.Count() Then
  For Each File In WScript.Arguments
    Push Files,File
  Next
Else
  Do While Not WScript.StdIn.AtEndOfStream
    Push Files,WScript.StdIn.ReadLine()
  Loop
End If
Call DragFiles(Files)

Sub DragFiles(Files)
Dim k,p
Dim File
Dim FolderName
Dim fso
Dim ie
Dim Folder

For k=0 To UBound(Files)
  File=Files(k)
  p=InStrRev(File,"\")
  If p Then
    If Left(File,p)<>FolderName Then
      If FolderName="" Then
        FolderName=Left(File,p)
      Else
        WScript.Echo "Folders differs."&vbLf&FolderName&vbLf&Left(File,p)
        WScript.Quit
      End If
    End If
    Files(k)=Mid(File,p+1)
  End If
Next
Set fso=CreateObject("Scripting.FileSystemObject")
If FolderName="" Then FolderName=fso.GetAbsolutePathName("")
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=True
ie.Navigate FolderName
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
Set Folder=ie.Document.Folder
For Each File In Files
  ie.Document.SelectItem Folder.Items().Item(File),1
Next
For Each File In Files
  ie.Document.SelectItem Folder.Items().Item(File),1+16
  Exit For
Next
ie.Document.SelectedItems.InvokeVerbEx "copy"
ie.Quit
End Sub

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
